#include<stdlib.h>
#include<stdio.h>
#include "macierz.h"

/* Funkcja tworzy macierz o podanej liczbie wierszy 'w' i kolumn 'k'.
 * Wartoscia zwracana jest adres (wskaznik) do tablicy o dlugosci 'w' zawierajacej adresy do tablic o dlugosci 'k' zawierajacych liczby rzeczywiste. */
float **utworz_macierz(int w, int k)
{
	float **m;
	int i=0;
	m=(float **)malloc(w * sizeof(float *));
	if (m==NULL) return NULL;
	for (i=0;i<w;i++)
	{
		*(m+i)=(float *)malloc(k * sizeof(float));
		if(*(m+i)==NULL)
	  	{
			zwolnij_macierz(m,i);
			return NULL;
		}
	}
	return m;
}

/* Funkcja wyswietla elementy macierzy 'm' posiadajacej 'w' wierszy i 'k' kolumn.  */
void wyswietl_macierz(float **m, int w, int k)
{
	int i,j;
	printf("\nMacierz %dx%d\n",w,k);
	for(i=0;i<w;i++)
 	{
  		for(j=0;j<k;j++)	printf("%6.2f ",*(*(m+i)+j));
 		printf("\n");
	}
}

/* Funkcja zwalnia pamiec zajeta przez macierz 'm' posiadajacej 'w' wierszy. */
void zwolnij_macierz(float **m, int w)
{
	while(w-- > 0) free(*(m+w));
	free(m);
}

/* Funkcja wczytuje wartosci macierzy z ekranu. Macierz 'm' musi byc utworzona dynamicznie za pomoca funkcji 'utworz_macierz' i musi posiadac 'w' wierszy i 'k' kolumn.
   Wartoscia zwracana jest adres macierzy **m
   */
float **wczytaj_macierz(float **m, int w, int k)
{
	int i,j;
 	printf("Podaj elementy macierzy %dx%d\n",w,k);
 	for(i=0;i<w;i++)
 	{
  		for(j=0;j<k;j++)
  		{
   		printf("[%d,%d] = ",i,j);
   		scanf("%f",*(m+i)+j);
  		}
 	}
	return m;
}

